-- Copyright (C) 2017 Tomoyuki Fujimori <moyu@dromozoa.com>
--
-- This file is part of dromozoa-commons.
--
-- dromozoa-commons is free software: you can redistribute it and/or modify
-- it under the terms of the GNU General Public License as published by
-- the Free Software Foundation, either version 3 of the License, or
-- (at your option) any later version.
--
-- dromozoa-commons is distributed in the hope that it will be useful,
-- but WITHOUT ANY WARRANTY; without even the implied warranty of
-- MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
-- GNU General Public License for more details.
--
-- You should have received a copy of the GNU General Public License
-- along with dromozoa-commons.  If not, see <http://www.gnu.org/licenses/>.

local hash = require "dromozoa.commons.hash"

local map = {}
local function test(key)
  local h = hash(key)
  -- print(("%08x"):format(h))
  assert(map[h] == nil)
  map[h] = true
end

test(0)
test(1)
test(2)
test(true)
test(false)
test("foo")
test("f")
test("f\0")
test("f\0\0")
test({})
test({{}})
test({{{}}})
test({ foo = "bar" })
test({ bar = "foo" })
